"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    SearchResponse,
    avro_parse,
    load_schema,
)


class SearchReferencesResponse(SearchResponse):
    """
    This is the response from `POST /references/search` expressed as JSON.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    _valueListName = "references"

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1

        return {
            "references": ga4gh_3_1_1.Reference,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1
        from protocols.protocol_8_4 import ga4gh as ga4gh_3_1_1

        return {
            "org.ga4gh.models.Reference": ga4gh_3_1_1.Reference,
            "org.ga4gh.methods.SearchReferencesResponse": ga4gh_3_1_1.SearchReferencesResponse,
        }

    __slots__ = [
        "nextPageToken",
        "references",
    ]

    def __init__(
        self,
        nextPageToken=None,
        references=list,
        validate=None,
        **kwargs
    ):
        """Initialise the ga4gh_3_1_1.SearchReferencesResponse model.

        :param nextPageToken:
            The continuation token, which is used to page through large result
            sets.   Provide this value in a subsequent request to
            return the next page of   results. This field will be
            empty if there aren't any additional results.
        :type nextPageToken: None | str
        :param references:
            The list of matching references.
        :type references: list[Reference]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "3.1.1"
